#!/bin/csh
set dir=`dirname $0`
if (-e ${dir}/ImageJ.cfg) then
  set jre=(`tr \[:space:\] \\n < ${dir}/ImageJ.cfg | grep -e \^jre -e \^-X`)
else
  set jre=(jre/bin/java -Xmx512m)
endif
set ij=(${dir}/$jre -jar ${dir}/ij.jar -ijpath $dir)
if ($#argv == 0) then
  $ij
else
  switch($argv[1])
    case -macro:
    case -batch:
      if ($#argv == 1) then
        echo echo missing macro or batch file name. '1>&2' | /bin/sh
      else if ($#argv == 2) then
        $ij $argv[1] "$argv[2]"
      else
        $ij $argv[1] "$argv[2]" "$argv[3-]"
      endif
      breaksw
    case -eval:
    case -run:
      if ($#argv == 1) then
        echo echo missing macro code or command. '1>&2' | /bin/sh
      else
        $ij $argv[1] "$argv[2-]"
      endif
      breaksw
    default:
#      $ij "$argv" ; breaksw
      $ij $argv ; breaksw
  endsw
endif
