
#if	!defined(XT) && !defined(XR)
#include <math.h>
#endif

#ifndef	FOM
#define FOM	double
#endif

void	I0Correction(int Nx,int y1,int y2,FOM **I,
		     int Nt,double *T,int Nl,int Nr)
{
	int	x,y,z;
	double	t,t2,xt2,x2t2,d,ti,xti,i,a,b,c,x0,x1,x2,xi;

#if	defined(XR)
#define CORRECTION(I0)	I[y][x]-=(I0)
#else
	double	i0;

#if	defined(XT)
/*
#define CORRECTION(I0)	I[y][x]/=(I0)
*/
#define CORRECTION(I0)	if ((i0=I0)>0.0) I[y][x]/=i0; else I[y][x]=0.0
#else
/*
#define CORRECTION(I0)	I[y][x]=log(I0/I[y][x])
*/
#define CORRECTION(I0)	I[y][x]=((i0=I0)>0.0 && I[y][x]>0.0)?log(i0/I[y][x]):0.0
#endif
#endif

#define X	(double)x

	if (Nt>0) {
	  for (x=0; x<Nx; x++) {
	    t=0.0; for (y=0; y<Nt; y++) t+=I[y][x]; T[x]=t/(double)Nt;
	  }
	  if (Nl>0)
	    if (Nr>0) {
	      z=Nx-Nr;
	      t2=xt2=x2t2=0.0;
	      for (x=0; x<Nl; x++) {
		t=T[x]; t2+=(t*t); xt2+=(X*t*t); x2t2+=(X*X*t*t);
	      }
	      for (x=z; x<Nx; x++) {
		t=T[x]; t2+=(t*t); xt2+=(X*t*t); x2t2+=(X*X*t*t);
	      }
	      d=x2t2*t2-xt2*xt2; t2/=d; xt2/=d; x2t2/=d;
	      for (y=y1; y<=y2; y++) {
		ti=xti=0.0;
		for (x=0; x<Nl; x++) {
		  t=T[x]; i=I[y][x]; ti+=(t*i); xti+=(X*t*i);
		}
		for (x=z; x<Nx; x++) {
		  t=T[x]; i=I[y][x]; ti+=(t*i); xti+=(X*t*i);
		}
		a=t2*xti-xt2*ti; b=x2t2*ti-xt2*xti;
		for (x=0; x<Nx; x++) CORRECTION((a*X+b)*T[x]);
	      }
	    }
	    else {
	      t2=0.0; for (x=0; x<Nl; x++) t2+=(T[x]*T[x]);
	      for (y=y1; y<=y2; y++) {
		c=0.0; for (x=0; x<Nl; x++) c+=(T[x]*I[y][x]);
		c/=t2; for (x=0; x<Nx; x++) CORRECTION(c*T[x]);
	      }
	    }
	  else
	    if (Nr>0) {
	      z=Nx-Nr;
	      t2=0.0; for (x=z; x<Nx; x++) t2+=(T[x]*T[x]);
	      for (y=y1; y<=y2; y++) {
		c=0.0; for (x=z; x<Nx; x++) c+=(T[x]*I[y][x]);
		c/=t2; for (x=0; x<Nx; x++) CORRECTION(c*T[x]);
	      }
	    }
	    else
	      for (y=y1; y<=y2; y++)
		for (x=0; x<Nx; x++) CORRECTION(T[x]);
	}
	else
	  if (Nl>0)
	    if (Nr>0) {
	      z=Nx-Nr;
	      x0=(double)(Nl+Nr);
	      x1=((double)(Nl-1)*(double)Nl+
		  (double)(Nx-1)*(double)Nx-
		  (double)(z -1)*(double)z )/2.0;
	      x2=((double)(Nl-1)*(double)Nl*(double)(2*Nl-1)+
		  (double)(Nx-1)*(double)Nx*(double)(2*Nx-1)-
		  (double)(z -1)*(double)z *(double)(2*z -1))/6.0;
	      d=x2*x0-x1*x1; x0/=d; x1/=d; x2/=d;
	      for (y=y1; y<=y2; y++) {
		i=xi=0.0;
		for (x=0; x<Nl; x++) {
		  i+=I[y][x]; xi+=(X*I[y][x]);
		}
		for (x=z; x<Nx; x++) {
		  i+=I[y][x]; xi+=(X*I[y][x]);
		}
		a=x0*xi-x1*i; b=x2*i-x1*xi;
		for (x=0; x<Nx; x++) CORRECTION(a*X+b);
	      }
	    }
	    else
	      for (y=y1; y<=y2; y++) {
		c=0.0; for (x=0; x<Nl; x++) c+=I[y][x];
		c/=(double)Nl; for (x=0; x<Nx; x++) CORRECTION(c);
	      }
	  else
	    if (Nr>0) {
	      z=Nx-Nr;
	      for (y=y1; y<=y2; y++) {
		c=0.0; for (x=z; x<Nx; x++) c+=I[y][x];
		c/=(double)Nr; for (x=0; x<Nx; x++) CORRECTION(c);
	      }
	    }
}
