#!/bin/csh
# usage : mm.csh TG/ {BPS}
#
alias STDERR 'echo echo 1\>\&2 "\!*" | /bin/sh'
#
if ($#argv != 1 && $#argv != 2) then
  STDERR usage : mm.csh TG/ \{BPS\} ; exit 1
endif
#
set tg=$argv[1]
if (!(-d $tg)) then
  STDERR $tg : directory not found. ; exit 1
endif
#
if ($#argv == 2) then
  @ bps = $argv[2]
  if ($bps < 1 || $bps > 16) then
    STDERR $bps : bad bits per sample \(BPS\) for tomograms. ; exit 1
  endif
else
  @ bps = 0
endif
#
#pid ${tg}/*.tif | \
ls $tg | grep .tif\$ | xargs -i@ pid ${tg}/@ | \
awk -v BPS=$bps \
    'NF==2 { if (min=="" || $1<min) min=$1; \
             if (max=="" || $2>max) max=$2 } \
     END { if (min!="" && max!="") { \
             printf "%s\t%s",min,max; \
             if (BPS!=0) printf "\t%.16f",(max-min)/(2^BPS-1); \
             printf "\n" }}'
