
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

#define ALLOC(type,noe)	(type *)malloc(sizeof(type)*(size_t)(noe))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,Sx,Sy,pv,x,y,a,Ph,Ch,Pv,Cv,v,h,V,H;
	char	*tmae="table memory allocation error.",
		*imae="image memory allocation error.";
	Cell	**P,**C;

	struct Table {
		char	*path;
		int	H,V;
	} **T;

	if (argc<8) Error("usage : pile_gray Nx Ny Sx Sy PV parent children");

#define NX	(argv[1])
#define NY	(argv[2])
#define SX	(argv[3])
#define SY	(argv[4])

	if ((Nx=abs(atoi(NX)))==0 ||
	    (Ny=abs(atoi(NY)))==0) Error("bad number of images.");

	if (argc-7!=Nx*Ny)
	    (void)fputs("number of images not match (warning).\n",stderr);

	Sx=abs(atoi(SX));
	Sy=abs(atoi(SY));

	if ((pv=atoi(argv[5]))<0 || pv>>8*sizeof(Cell))
	    Error("bad pixel value for space filling.");

	if ((T=ALLOC(struct Table *,Nx))==NULL) Error(tmae);

	for (x=0; x<Nx; x++) {
	    if ((T[x]=ALLOC(struct Table,Ny))==NULL) Error(tmae);

	    for (y=0; y<Ny; y++) {
		T[x][y].path=NULL; T[x][y].H=T[x][y].V=0;
	    }
	}

#define CHECK	{ \
	if (argv[a][0]!='-') \
	    ReadImageFile(T[x][y].path=argv[a],&(T[x][y].H),&(T[x][y].V), \
			  NULL,NULL,NULL); \
}

	a=7;
	if (*NX!='-')
	    for (x=0; x<Nx && a<argc; x++)
		if (*NY!='-')
		    for (y=0; y<Ny && a<argc; y++, a++) CHECK
		else
		    for (y=Ny-1; y>=0 && a<argc; y--, a++) CHECK
	else
	    if (*NY!='-')
		for (y=0; y<Ny && a<argc; y++)
		    for (x=0; x<Nx && a<argc; x++, a++) CHECK
	    else
		for (y=Ny-1; y>=0 && a<argc; y--)
		    for (x=0; x<Nx && a<argc; x++, a++) CHECK

	for (Ph=(*SX!='-')?Sx:0, x=0; x<Nx; x++, Ph+=(Ch+Sx)) {
	    Ch=0; for (y=0; y<Ny; y++) if (T[x][y].H>Ch) Ch=T[x][y].H;

	    for (y=0; y<Ny; y++) T[x][y].H=Ph+(Ch-T[x][y].H)/2;
	}
	if (*SX=='-') Ph-=Sx;

	for (Pv=(*SY!='-')?Sy:0, y=0; y<Ny; y++, Pv+=(Cv+Sy)) {
	    Cv=0; for (x=0; x<Nx; x++) if (T[x][y].V>Cv) Cv=T[x][y].V;

	    for (x=0; x<Nx; x++) T[x][y].V=Pv+(Cv-T[x][y].V)/2;
	}
	if (*SY=='-') Pv-=Sy;

	if ((P=ALLOC(Cell *,Pv))==NULL) Error(imae);

	for (v=0; v<Pv; v++) {
	    if ((P[v]=ALLOC(Cell,Ph))==NULL) Error(imae);

	    for (h=0; h<Ph; h++) P[v][h]=(Cell)pv;
	}
	for (x=0; x<Nx; x++)
	for (y=0; y<Ny; y++)
	    if (T[x][y].path!=NULL) {
		ReadImageFile(T[x][y].path,&Ch,&Cv,NULL,&C,NULL);

		for (V=T[x][y].V, v=0; v<Cv; v++, V++) {
		    for (H=T[x][y].H, h=0; h<Ch; h++, H++)
			if ((P[V][H]=C[v][h])>pv) pv=C[v][h];

		    free(C[v]);
		}
		free(C);
	    }

	StoreImageFile(argv[6],Ph,Pv,
		       (pv<2)?1:(pv<4)?2:(pv<16)?4:(pv<256)?8:(pv<65536)?16:32,
		       P,NULL);

	return 0;
}
