#!/bin/csh
# usage : plot_x11.csh HG {CTV1 CTV2}
#
alias STDERR 'echo echo 1\>\&2 "\!*" | /bin/sh'
#
if ($#argv != 1 && $#argv != 3) then
  STDERR usage : plot_x11.csh HG \{CTV1 CTV2\} ; exit 1
endif
#
set hg=$argv[1]
if (!(-e $hg)) then
  STDERR $hg : HG \(histogram\) file not found. ; exit 1
endif
#
if ($#argv == 1) then
  set x='*:*'
else
  set x=`echo "$argv[2] ; $argv[3]" | bc -l | sed 'N; s/\n/:/'`
  if (`echo $x | awk -F: '{ print (NF!=2 || $1>=$2) }'`) then
    STDERR "$argv[2]" \~ "$argv[3]" : bad CT-value range. ; exit 1
  endif
endif
#
gnuplot -persist <<fin
  set terminal x11
  unset key ; set grid
  set logscale y ; set xrange [${x}] 
  set label "${hg}" at graph 0.9,0.85 right
  plot "< cat $hg | tr , ' '" using ((\$2+\$3)/2):4 with lines linewidth 2
fin
