
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_r.h"
#include "sif_f.h"

extern void	Error(char *msg),
		I0Correction(int Nx,int y1,int y2,FOM **I,
			     int Nt,double *T,int Nl,int Nr);

#if	defined(XR)
#define ORG	"RR/"
#define RUN	"rr2sg"
#define NEW	"SG/"
#else
#define ORG	"RI/"
#define RUN	"ri2sg"
#define NEW	"SG/"
#endif

#define LEN	2048

int	main(int argc,char **argv)
{
	char	**path,form[LEN],str[LEN];
	int	Nx,Ny,Nz,Nt,Nl,Nr,y1,y2,ny,z,y,x,len;
	double	*T=NULL;
	FOM	***F,**I,*f;

	if (argc!=7 && argc!=9)
	Error("usage : " RUN " " ORG " NF top left right {layer1 layer2} " NEW);

	path=CheckSliceImages_Float(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if (Nz<1) Error("too few views.");

	free(path[--Nz]);

	if ((Nt=atoi(argv[3]))>=Ny) Error("bad top margin.");

	if ((Nl=atoi(argv[4]))<0) Nl=0;
	if ((Nr=atoi(argv[5]))<0) Nr=0;
	if (Nl+Nr>=Nx) Error("bad side margin.");

	if (argc==7) {
	    y1=0; y2=Ny-1;
	}
	else
	    if ((y1=atoi(argv[6]))<0 ||
		(y2=atoi(argv[7]))>=Ny || y1>y2) Error("bad slice range.");

	ny=y2-y1+1;

	if ((Nt>0 && (T=(double *)malloc(sizeof(double)*Nx))==NULL) ||
	    (F=(FOM ***)malloc(sizeof(FOM **)*ny))==NULL ||
	    (*F=(FOM **)malloc(sizeof(FOM *)*ny*Nz))==NULL ||
	    (**F=(FOM *)malloc(sizeof(FOM)*ny*Nz*Nx))==NULL)
	    Error("memory allocation error.");

	for (z=1; z<Nz; z++) F[0][z]=F[0][z-1]+Nx;
	for (y=1; y<ny; y++) {
	    F[y]=F[y-1]+Nz; for (z=0; z<Nz; z++) F[y][z]=F[y][z-1]+Nx;
	}
	for (z=0; z<Nz; z++) {
	    ReadImageFile_Raw(path[z],&x,&y,&I);
	    if (Nx!=x || Ny!=y) Error("image size not match.");

	    I0Correction(Nx,y1,y2,I,Nt,T,Nl,Nr);

	    for (y=y1; y<=y2; y++) {
		f=F[y-y1][z]; for (x=0; x<Nx; x++) f[x]=I[y][x];
	    }
	    for (y=0; y<Ny; y++) free(I[y]); free(I); free(path[z]);
	}
	if (Nt>0) free(T); free(path);

	len=1; for (y=10; y<Ny; y*=10) ++len;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[argc-1],len);

	for (y=y1; y<=y2; y++) {
	    (void)sprintf(str,form,y);
	    StoreImageFile_Float(str,Nx,Nz,F[y-y1],SIF_F_desc);
	    (void)printf("%d\t%s\n",y,SIF_F_desc);
	}
	free(**F); free(*F); free(F);

	return 0;
}
