
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_r.h"
#include "sif_f.h"

extern void	Error(char *msg),
		I0Correction(int Nx,int y1,int y2,FOM **I,
			     int Nt,double *T,int Nl,int Nr);

#if	defined(XR)
#define ORG	"RR/"
#define RUN	"rr2xr"
#define NEW	"XR/"
#else
#define ORG	"RI/"
#if	defined(XT)
#define RUN	"ri2xt"
#define NEW	"XT/"
#else
#define RUN	"ri2xp"
#define NEW	"XP/"
#endif
#endif

#define LEN	2048

int	main(int argc,char **argv)
{
	char	**path,str[LEN];
	int	Nx,Ny,Nz,Nt,Nl,Nr,len,z,x,y;
	double	*T=NULL;
	FOM	**I;

	if (argc!=7) Error("usage : " RUN " " ORG " NF top left right " NEW);

	path=CheckSliceImages_Float(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if ((Nt=atoi(argv[3]))>=Ny) Error("bad top margin.");

	if ((Nl=atoi(argv[4]))<0) Nl=0;
	if ((Nr=atoi(argv[5]))<0) Nr=0;
	if (Nl+Nr>=Nx) Error("bad side margin.");

	if (Nt>0 && (T=(double *)malloc(sizeof(double)*Nx))==NULL)
	    Error("memory allocation error.");

	for (len=0; argv[1][len]!='\0'; len++) ; ++len;

	for (z=0; z<Nz; z++) {
	    ReadImageFile_Raw(path[z],&x,&y,&I);
	    if (Nx!=x || Ny!=y) Error("image size not match.");

	    I0Correction(Nx,0,Ny-1,I,Nt,T,Nl,Nr);

	    (void)sprintf(str,"%s/%s",argv[6],path[z]+len);
	    StoreImageFile_Float(str,Nx,Ny,I,SIF_F_desc);
	    (void)printf("%d\t%s\n",z,SIF_F_desc);

	    for (y=0; y<Ny; y++) free(I[y]); free(I); free(path[z]);
	}
	if (Nt>0) free(T); free(path);

	return 0;
}
