
#include <stdio.h>
#include <stdlib.h>
#include "rif_f.h"
#include "rif_r.h"

#define LEN	2048

void	ReadImageFile_Raw(char *path,int *Nx,int *Ny,FOM ***fom)
{
	int	bps,n,y,x;
	char	*range,str[8][LEN],*u_c,
		*u="using integer PV as is floating-point PV",
		*c="converting PV by TIFF image description tag";
	double	min,max,base,step;

	if ((bps=ReadImageFile_Float(path,Nx,Ny,fom,&range))!=0) {
	    if (range!=NULL) {
		if ((n=sscanf(range,"%s %s %s %s %s %s %s %s",
				    str[0],str[1],str[2],str[3],
				    str[4],str[5],str[6],str[7]))==2 || n==6)
		    if (sscanf(str[n-2],"%lf",&min)!=1 ||
			sscanf(str[n-1],"%lf",&max)!=1 || min>=max)
			u_c=u;
		    else {
			u_c=c; base=min; step=(max-min)/(double)((1ULL<<bps)-1);
		    }
		else
		    u_c=((n!=3 && n!=4 && n!=8) ||
			 sscanf(str[n-2],"%lf",&base)!=1 ||
			 sscanf(str[n-1],"%lf",&step)!=1 || step<=0.0)?u:c;

		if (u_c==c)
		    for (y=0; y<*Ny; y++)
		    for (x=0; x<*Nx; x++) (*fom)[y][x]=base+step*(*fom)[y][x];

		free(range);
	    }
#ifdef	U_C
	    else
		u_c=u;

	    (void)fprintf(stderr,"%s : %s (warning).\n",path,u_c);
#endif
	}
	else
	    if (range!=NULL) free(range);
}
