#!/bin/csh
alias STDERR 'echo echo \!* 1\>\&2 | /bin/sh'
#
set tmp=/tmp/rp+mf_ij.$$
#
if ($#argv < 4) then
  STDERR 'usage : rp+mf_ij.csh log\&HIS view scan layer \{Wm,Ws ...\}' ; exit 1
endif
#
mkdir $tmp
#
set mm=(`rp.csh $argv[1-3] ${tmp}/RP.tif`)
if ($status) then
  rm -rf $tmp ; exit 1
endif
#
set xy=(`pig ${tmp}/RP.tif`)
if ($argv[4] < 0 || $argv[4] >= $xy[2]) then
  STDERR $argv[4] : bad layer. ; rm -rf $tmp ; exit 1
endif
#
set p=\"${tmp}/RP.tif\"
#
@ i = $#argv
while ($i > 4)
  set csv=`echo $argv[$i] | cut -d, -f1,2` ; @ i -= 1
#
  set wms=(`echo $csv | tr , ' '`)
  if ($#wms < 2) then
    STDERR -n $csv : missing mountain or sampling width
    if ($#wms == 0) then
      STDERR . ; rm -rf $tmp ; exit 1
    endif
    STDERR '\ \(warning\).'
    set wms=($wms $wms)
  endif
  if ($wms[1] < 0 || $wms[2] < 2) then
    STDERR $wms[1] or $wms[2] : bad mountain or sampling width.
    rm -rf $tmp ; exit 1
  endif
  set mm=(`mf.csh ${tmp}/RP.tif $wms ${tmp}/${csv}.tif | \
           awk -v min=$mm[1] -v max=$mm[2] \
               '{ print ($1<min)?$1:min,($2>max)?$2:max }'`)
#
  set p=(\"${tmp}/${csv}.tif\","$p")
end
#
cat <<fin >${tmp}/macro.txt
  p=newArray(${p});
  for (i=0; i<p.length; i++) {
    open(p[i]);
    x=${xy[1]}-1; y=${argv[4]}; makeLine(0,y,x,y);
    run("Plot Profile"); Plot.setLimits(0,x,${mm[1]},${mm[2]});
  }
fin
IJ -macro ${tmp}/macro.txt
#
rm -rf $tmp
