#!/bin/csh
alias STDERR 'echo echo \!* 1\>\&2 | /bin/sh'
#
if ($#argv != 3 && $#argv != 4) then
  STDERR usage : rp.csh log\\\&HIS view scan \\\{RP.tif\\\} ; exit 1
endif
#
set a=`echo $argv[1] | sed -e s/\\.log\$//g -e s/\\.HIS\$//g`
foreach ext (log HIS)
  if (!(-e ${a}.$ext)) then
    STDERR ${a}.$ext : file not found. ; exit 1
  endif
end
#
set rp=(`( echo -n ${argv[2]},${argv[3]}, ; head -1 ${a}.log ) | \
         awk -F, '{ if ($2<0 || $2>=$3-1) print $2,"scan",$3-1; else \
                    if ($1<0 || $1>=$4) print $1,"view",$4; else \
                    print $5,$5+1+$3*$1+$2 }'`)
if ($#rp == 3) then
  STDERR $rp[1] : bad $rp[2] number \\\(${rp[2]}s = ${rp[3]}\\\). ; exit 1
else if ($#argv == 4) then
  his2rp ${a}.HIS $rp $argv[4]
else
  echo $rp | tr ' ' \\t
endif
