
typedef unsigned char	Byte;
typedef	unsigned short	Word2;
typedef unsigned int	Word4;

static FILE	*file;
static char	*UEOF="unexpected end of file.";

static int	Get1()
{
	int	code=fgetc(file);

	if (code==EOF) Error(UEOF);

	return code;
}

static void	Nread(ptr,size)
Byte		*ptr;
size_t		size;
{
	if (fread(ptr,size,(size_t)1,file)!=1) Error(UEOF);
}

static void	Rread(ptr,size)
Byte		*ptr;
size_t		size;
{
	for (ptr+=size; size>0; size--) *(--ptr)=(Byte)Get1();
}

static void	(*Read)();

static Word2	Get2()
{
	Word2	w2;

	(*Read)((Byte *)&w2,sizeof(w2)); return w2;
}

static Word4	Get4()
{
	Word4	w4;

	(*Read)((Byte *)&w4,sizeof(w4)); return w4;
}

#define Seek(ofs,org)	if (fseek(file,ofs,org)) Error(UEOF)

static Word4	IFD;

static Word2	GetIFD(tag)
Word2		tag;
{
	Word2	tags;

	Seek((long)IFD,SEEK_SET);
	for (tags=Get2(); tags>0; tags--) {
	    if (Get2()==tag) return Get2();

	    Seek(10L,SEEK_CUR);
	}
	return 0;
}

static Word2	GetIFD3(tag,def)
Word2		tag,def;
{
	return (GetIFD(tag)==3 && Get4()==1)?Get2():def;
}

static Word4	GetIFD4(tag,def)
Word2		tag;
Word4		def;
{
	switch(GetIFD(tag)) {
	    case 3 : if (Get4()==1) return Get2(); break;
	    case 4 : if (Get4()==1) return Get4(); break;
	}
	return def;
}

static Byte	*Copy(offset,bytes,name)
Word4		offset,bytes;
char		*name;
{
	Byte	*buf;
	char	msg[80];

	if ((buf=(Byte *)malloc((size_t)bytes))==NULL) {
	    (void)sprintf(msg,"no allocatable memory for %s buffer.",name);
	    Error(msg);
	}
	Seek((long)offset,SEEK_SET); Nread(buf,(size_t)bytes); return buf;
}

#define NoB_Error(name)	Error("no or bad " name ".")

static struct STRIP {
		Word4	byte_count;
		union {
			Word4	offset;
			Byte	*byte;
		} ob;
	} *strip;

#define SBC(idx)	(strip[idx].byte_count)
#define SO(idx)		(strip[idx].ob.offset)
#define SB(idx)		(strip[idx].ob.byte)

static void	ReadStrip(SPI)
Word4		SPI;
{
	char	*BNOSBC="bad number of strip byte counts.",
		*BNOSO="bad number of strip offsets.";
	Word4	idx;

	if ((strip=(struct STRIP *)malloc(sizeof(*strip)*(size_t)SPI))==NULL)
	    Error("no allocatable memory for strip.");

	switch(GetIFD(0x117)) {
	    case 3 :
		if (Get4()!=SPI) Error(BNOSBC);

		if (SPI>2) Seek((long)Get4(),SEEK_SET);

		for (idx=0; idx<SPI; idx++) SBC(idx)=Get2();

		break;
	    case 4 :
		if (Get4()!=SPI) Error(BNOSBC);

		if (SPI>1) Seek((long)Get4(),SEEK_SET);

		for (idx=0; idx<SPI; idx++) SBC(idx)=Get4();

		break;
	    default :
		NoB_Error("strip byte counts");
	}
	switch(GetIFD(0x111)) {
	    case 3 :
		if (Get4()!=SPI) Error(BNOSO);

		if (SPI>2) Seek((long)Get4(),SEEK_SET);

		for (idx=0; idx<SPI; idx++) SO(idx)=Get2();

		break;
	    case 4 :
		if (Get4()!=SPI) Error(BNOSO);

		if (SPI>1) Seek((long)Get4(),SEEK_SET);

		for (idx=0; idx<SPI; idx++) SO(idx)=Get4();

		break;
	    default :
		NoB_Error("strip offsets");
	}
	for (idx=0; idx<SPI; idx++) SB(idx)=Copy(SO(idx),SBC(idx),"strip byte");
}

#define Put1(code)	(void)fputc(code,file)

static void	Nwrite(ptr,size)
Byte		*ptr;
size_t		size;
{
	(void)fwrite(ptr,size,(size_t)1,file);
}

static void	Rwrite(ptr,size)
Byte		*ptr;
size_t		size;
{
	for (ptr+=size; size>0; size--) Put1((int)*(--ptr));
}

static void	(*Write)();

static void	Put2(w2)
Word2		w2;
{
	(*Write)((Byte *)&w2,sizeof(w2));
}

static void	Put4(w4)
Word4		w4;
{
	(*Write)((Byte *)&w4,sizeof(w4));
}

static void	PutIFD(tag,type,count)
Word2		tag,type;
Word4		count;
{
	Put2(tag); Put2(type); Put4(count);
}

static void	PutIFD3(tag,data)
Word2		tag,data;
{
	PutIFD(tag,(Word2)3,(Word4)1); Put2(data); Put2((Word2)0);
}

static void	PutIFD4(tag,count,data)
Word2		tag;
Word4		count,data;
{
	PutIFD(tag,(Word2)4,count); Put4(data);
}
